#!/usr/bin/env node

'use strict';
const program = require('commander');
const build = require('../runner/build');
program
    .option(
        '-e, --entry [entry]',
        'entry files (,) separated, glob mode , need to quote',
        val => {
            return val.split(',');
        }, ['index.html']
    )
    .option('--cdn [cdn]', 'static cdn domain')
    .option('--min [min]', 'min file', true)
    .option('--hash [hash]', 'enable hash filename', true)
    .option('--library [library]', '设置包名称')
    .option('--target [target]', '设置包导出格式 , 可选值: `umd|amd|amd-require|commonjs2|this|window|global|commonjs|system|jsonp`')
    .option('--output [output]', 'output path', "dist")
    .option('--config [config]', 'config file , default ".ksr.conf.js"', '.ksr.conf.js')
    .option('-s, --static [static]', `static dir , 逗号分隔 , 默认是当前目录下的dist`, val => {
        return val.split(',');
    }, ['dist'])
    .parse(process.argv);

build(program);