#!/usr/bin/env node
'use strict';
const program = require('commander');
const dev = require('../runner/dev');

program
    .option(
        '-e, --entry [entry]',
        'entry files (,) separated, glob mode , need to quote',
        val => {
            return val.split(',');
        },
        ['index.html']
    )
    .option(
        '-m, --mock [mock]',
        'mock files (,) separated , glob mode , need to quote , default "./mock/**/*.js , ./mock/**/*.json"',
        val => {
            return val.split(',');
        },
        ['./mock/**/*.js', './mock/**/*.json']
    )
    .option('-p, --port [port]', 'dev start port , default 3601', 3601)
    .option('-h, --host [host]', 'dev start host , default 127.0.0.1', '127.0.0.1')
    .option('--cdn [cdn]', 'static cdn domain')
    .option('--proxy [proxy]', 'proxy file , default ".proxy.js"', '.proxy.js')
    .option('--config [config]', 'config file , default ".ksr.conf.js"', '.ksr.conf.js')
    .option('--server-config [serverConfig]', 'serverConfig file , default ".ksr.serve.conf.js"', '.ksr.serve.conf.js')
    .option('--middleware [middleware]', `middleware file , 逗号分隔`, val => {
        return val.split(',');
    })
    .option('-s, --static [static]', `static dir , 逗号分隔 , 默认是当前目录下的dist`, val => {
        return val.split(',');
    }, ['dist'])
    .option('--mport [mport]', 'mock start port , default 3500', 3500)
    .option('--mhost [mhost]', 'mock start host , default 127.0.0.1', '127.0.0.1')
    .parse(process.argv);

dev(program);
