#!/usr/bin/env node
'use strict';
const program = require('commander');
const mock = require('../runner/mock');
program
    .option(
        '-f, --files [files]',
        'mock files (,) separated ,glob mode , need to quote , default "./mock/**/*.js , ./mock/**/*.json"',
        val => {
            return val.split(',');
        },
        ['./mock/**/*.js', './mock/**/*.json', '!./node_modules/**/*']
    )
    .option('-p, --port [port]', 'mock start port, default 3500', 3500)
    .option('-h, --host [host]', 'mock start host, default 127.0.0.1', '127.0.0.1')
    .parse(process.argv);

mock(program);
