const webpack = require("webpack");
const path = require("path");
const fs = require('fs');
module.exports = function(program) {
  let plugins = [];
  let alias = {};

  let intactVue = path.resolve(
    process.cwd(),
    "node_modules/intact-vue/package.json"
  );

  try {
    const statIntactVue = fs.statSync(intactVue);
    if (statIntactVue && statIntactVue.isFile()) {
      alias["intact$"] = "intact-vue/dist/intact.vue.js";
    }
  } catch (error) {}

  let intact = path.resolve(process.cwd(), "node_modules/intact/package.json");
  try {
    const statIntact = fs.statSync(intact);
    if (statIntact && statIntact.isFile()) {
      plugins.push(
        new webpack.ProvidePlugin({
          Intact: "intact"
        })
      );
    }
  } catch (error) {}

  return {
    resolve: {
      extensions: [".vdt"],
      alias: alias
    },
    plugins: plugins,
    module: {
      rules: [
        {
          test: /\.vdt$/,
          use: [
            "happypack/loader?id=babel",
            {
              loader: "vdt-loader",
              options: {
                delimiters: ["{{", "}}"],
                skipWhitespace: true,
                noWith: true
              }
            }
          ]
        }
      ]
    }
  };
};
