const progress = require("progress");
const chalk = require("chalk");
const webpack = require("webpack");
module.exports = function showProcess() {
  var stream = process.stderr;
  if (!stream.isTTY) {
    return function() {};
  }
  const progressBar = new progress(
    `building [:bar] ${chalk.green(":percent")} :elapsed :rate/bps :eta/s :msg`,
    {
      complete: chalk.green("="),
      incomplete: chalk.white("="),
      width: 30,
      total: 100
    }
  );
  return new webpack.ProgressPlugin(function(percentage, msg) {
    progressBar.update(percentage, { msg: msg });
  });
};
