/**
 * 创建style 对应的 loader
 * @param {*} loader
 * @param {*} loaderOptions
 */
const postcssConf = require("./postcssConf");

function styleLoaders(isDev) {
  return function Loaders(loader, loaderOptions) {
    if (loader) {
      loader = {
        loader: loader + "-loader",
        options: Object.assign({}, loaderOptions)
      };
    }
    const loaders = [
      {
        loader: "css-loader"
      }
    ];

    loaders.push({
      loader: "postcss-loader",
      options: {
        sourceMap: true,
        ctx: postcssConf()
      }
    });

    loaders.push({
      loader: "resolve-url-loader"
    });

    if (loader) {
      loaders.push(loader);
    }

    return loaders;
  };
}

module.exports = styleLoaders;
